﻿using UnityEditor.Experimental.GraphView;
using UnityEngine;

namespace ImageProcessingGraph.Editor
{
    [System.Serializable]
    public struct GraphConnection
    {
        public GraphPort inputPort;
        public GraphPort outputPort;

        [SerializeField] public Edge internalEdge;
        
        public GraphConnection(GraphPort inputPort, GraphPort outputPort, Edge internalEdge)
        {
            this.inputPort = inputPort;
            this.outputPort = outputPort;
            this.internalEdge = internalEdge;
        }

        public GraphConnection(string inputNodeGuid, int inputPortID, string inputNodeType, string outputNodeGuid, int outputPortID, string outputNodeType, Edge internalEdge)
        {
            this.inputPort = new GraphPort(inputNodeGuid, inputPortID, inputNodeType);
            this.outputPort = new GraphPort(outputNodeGuid, outputPortID, outputNodeType);
            this.internalEdge = internalEdge;
        }

        public void SetInternalEdge(Edge edge)
        {
            this.internalEdge = edge;
        }
    }

    [System.Serializable]
    public struct GraphPort
    {
        public string nodeID;
        public string nodeType;
        public int portID;


        public GraphPort(string nodeID, int portID, string nodeType)
        {
            this.nodeID = nodeID;
            this.portID = portID;
            this.nodeType = nodeType;
        }
    }
}