﻿using System.ComponentModel.Composition.Primitives;
using ImageProcessingGraph.Editor.Nodes.NodeAttributes;
using Unity.Collections;
using UnityEditor;
using UnityEngine;

namespace ImageProcessingGraph.Editor.Nodes.Output
{
    [NodeInfo("Texture Export", "Export/Export Texture", true)]
    public class Texture2DOutput : BaseImageNode
    {
        [NodeAttributes.Input("")] public ImageData inputPixels;
        [NodeAttributes.Input("File Name")] public string fileName;
        [NodeAttributes.Input("File Path")] public string fileDirectory;

        public enum ExportType
        {
            Texture2D,
            PNG
        }
        
        [NodeAttributes.Input("Export Type")] public ExportType exportType;

        public override void Process()
        {
            switch (exportType)
            {
                case ExportType.Texture2D:
                    AssetDatabase.CreateAsset(inputPixels.ToTexture2D(), $"{fileDirectory}/{fileName}.asset");
                    break;
                case ExportType.PNG:
                    inputPixels.ExportPNG($"{fileDirectory}/{fileName}.png");
                    break;
            }
        }
    }
}